C======================================================================C
C     PYTHIA$SOURCE:CDFLND.CIN                                         C
C----------------------------------------------------------------------C
C     I/O swiches for CDF interface of PYTHIA/JETSET                   C
C     and conversion options                                           C
C----------------------------------------------------------------------C
C                                                                      C
C     CLNDL( 1) = Swich for HEPEVT format event dump                   C
C     CLNDL( 2) = Swich for PYTHIA format event dump : LULIST(1-3)     C
C     CLNDL( 3) = Swich for PARTICLE TABLE output    : LULIST(11)      C 
C     CLNDL( 4) = Swich for DECAY    TABLE output    : LULIST(12)      C
C     CLNDL( 5) = Swich for JETSET    DATA output    : LULIST(13)      C
C     CLNDL( 6) = Swich for PARTICLE  DATA output    : LUUPDA(1,*)     C
C     CLNDL( 7) = Swich for PARTICLE  DATA input     : LUUPDA(2,*))    C
C     CLNDL( 8) = not used                                             C
C     CLNDL( 9) = not used                                             C
C     CLNDL(10) = Swich for RANDOM NUMBER STATE output (1) INITIAL     C
C     CLNDL(11) = Swich for RANDOM NUMBER STATE output (2) FINAL       C
C     CLNDL(12) = Swich for RANDOM NUMBER STATE output (3) EACH_N      C
C     CLNDL(13) = Swich for RANDOM NUMBER STATE output (4) USER        C
C     CLNDL(14) = Swich for RANDOM NUMBER STATE input  (1) ALL         C
C     CLNDL(15) = Swich for RANDOM NUMBER STATE input  (2) FINAL       C
C     CLNDL(16) = Swich for RANDOM NUMBER STATE input  (3) FROM        C
C     CLNDL(17) = Swich for user calling of CWRANS                     C
C     CLNDL(18) = not used                                             C
C     CLNDL(19) = not used                                             C
C     CLNDL(20) = Swich for HEPEVT conversion                          C
C     CLNDL(21) = Swich for GENP   conversion                          C
C     CLNDL(22-26) are not used                                        C
C     CLNDL(27) = Swich for CDF particle list output                   C
C     CLNDL(28) = Swich for LUDATA2 output                             C
C     CLNDL(29) = Swich for LUJETS/GENP conversion event dump          C
C     CLNDL(30) = Swich for GENP format event dump                     C
C                                                                      C
C......................................................................C
C                                                                      C
C     CLNDI( 1) = Log. unit for HEPEVT format event dump               C
C     CLNDI( 2) = Log. unit for PYTHIA format event dump : LULIST(1-3) C
C     CLNDI( 3) = Log. unit for PARTICLE TABLE output    : LULIST(11)  C
C     CLNDI( 4) = Log. unit for DECAY    TABLE output    : LULIST(12)  C
C     CLNDI( 5) = Log. unit for JETSET    DATA output    : LULIST(13)  C
C     CLNDI( 6) = Log. unit for PARTICLE  DATA output    : LUUPDA(1,*) C
C     CLNDI( 7) = Log. unit for PARTICLE  DATA input     : LUUPDA(2,*) C
C     CLNDI( 8) = Log. unit for RANDOM NUMBER STATE output by RLUGET   C
C     CLNDI( 9) = Log. unit for RANDOM NUMBER STATE input by RLUSET    C
C     CLNDI(10) = Total number of event dump                           C
C     CLNDI(11) = Jump for event dump                                  C
C     CLNDI(12) = Output level for PYTHIA format output (1-3)          C
C     CLNDI(13) = Position of random number state in file to start     C
C     CLNDI(14) = Total number of record in random number file         C
C     CLNDI(15) = Total number of random number states to be printed   C
C     CLNDI(16) = Jump for printing random number state                C
C     CLNDI(17-26) are not used                                        C
C     CLNDI(27) = Log. unit for CDF particle list output               C
C     CLNDI(28) = Log. unit for LUDATA2 output                         C
C     CLNDI(29) = Log. unit for LUJETS/GENP conversion event dump      C
C     CLNDI(30) = Log. unit for GENP format event dump                 C
C                                                                      C
C......................................................................C
C                                                                      C
C     CLNDR(1-30) are not used                                         C
C                                                                      C
C......................................................................C
C                                                                      C
C     CLNDC( 1) = File name for HEPEVT format event dump               C
C     CLNDC( 2) = File name for PYTHIA format event dump : LULIST(1-3) C
C     CLNDC( 3) = File name for PARTICLE TABLE output    : LULIST(11)  C
C     CLNDC( 4) = File name for DECAY    TABLE output    : LULIST(12)  C
C     CLNDC( 5) = File name for JETSET    DATA output    : LULIST(13)  C
C     CLNDC( 6) = File name for PARTICLE  DATA output    : LUUPDA(1,*) C
C     CLNDC( 7) = File name for PARTICLE  DATA input     : LUUPDA(2,*) C
C     CLNDC( 8) = File name for RANDOM NUMBER STATE output by RLUGET   C
C     CLNDC( 9) = File name for RANDOM NUMBER STATE input  by RLUSET   C
C     CLNDC(10-26) are not used                                        C
C     CLNDC(27) = File name for CDF particle list output               C
C     CLNDC(28) = File name for LUDATA2 output                         C
C     CLNDC(29) = File name for LUJETS/GENP conversion event dump      C
C     CLNDC(30) = File name for GENP format event dump                 C
C                                                                      C
C----------------------------------------------------------------------C
C
      LOGICAL CLNDL
      INTEGER CLNDI
      REAL*4  CLNDR
      CHARACTER*72 CLNDC
      COMMON/CDFPYT/CLNDL(30),CLNDI(30),CLNDR(30),CLNDC(30)
C
C.....Conversion option
      LOGICAL NOPYTH,NOJETS,NOSTRG,NOUNST
      COMMON/CVLOPT/NOPYTH,NOJETS,NOSTRG,NOUNST
C
C......................................................................C
