*--------------------------------------------------------------*
*                Converted with cdf2F by G.Velev               *
*--------------------------------------------------------------*
C======================================================================C
      SUBROUTINE CLRCVT
C----------------------------------------------------------------------C
C     READ IN CVTABLE.LND AND FILL /CVTLND/,/CVTLKC/                   C
C----------------------------------------------------------------------C
C Revision history                                                     C
C     1990-10-04 H.Iso Original creation for PYTHIA 5.4 and JETSET 7.3 C
C----------------------------------------------------------------------C
C
      implicit none
C
C.....Conversion table
#include "cvtlnd.inc" 
C
C.....CDF include file
#include "inc/erlevl.inc" 
C
C.....Local use
      INTEGER STATUS,IUNIT,IERR
      INTEGER INDEX,I,J,KC
      CHARACTER*80 FILNAM
      CHARACTER*16 NAMEP,NAMEA
      CHARACTER* 1 CDUMMY
C
C.....External function
      INTEGER UIGTLU
C
C...................................................End of declarations/
C
C-----Initialize CVTKC
      DO 1 KC=1,MXKC
      INDXKC(KC)=0
    1 NKC(KC)=0
C
C-----Open table
C.....Check if conversion table exists
      CALL CHKLOG('CDFPYTC','PYTHIA$LIBRARY:CVTABLE6.DBT',FILNAM,IERR)
      IF(IERR.NE.0) THEN
         CALL ERLOGR('CLRCVT',ERWARN,0,0
     &        ,'Error while attempting to open CDFPYTC input file')
         RETURN
      ELSE
C
C........Get a free LOGICAL unit and open the file
         STATUS=UIGTLU(IUNIT)
C
#if defined (IBM)
         CALL IBMFI(FILNAM,IUNIT)
         OPEN(UNIT=IUNIT

#else 
#if defined(RS6000) || defined(LINUX)
          OPEN(UNIT=IUNIT,FILE=FILNAM  
#else     
         OPEN(UNIT=IUNIT,FILE=FILNAM
     &       ,READONLY,SHARED         
#endif
#endif
     &       ,STATUS='OLD',IOSTAT=IERR)
C
         IF(IERR.NE.0) THEN
            CALL ERLOGR('CLRCVT',ERWARN,IERR,0,
     &          'Error while attempting to open CDFPYTC input file')
            RETURN
         ENDIF
      ENDIF
C
C-----Readin table
      READ(IUNIT,1001) CDUMMY
   10 READ(IUNIT,1000,END=19)
     &    INDEX,LNDKC(INDEX),LNDKCI(INDEX),NAMEP,NAMEA
     &   ,(LNDKF(I,INDEX),I=1,2),(CDFIDL(J,INDEX),J=1,2),CDFTCL(INDEX)
 1000 FORMAT(1X,I5,1X,I3,1X,I3,1X,A16,1X,A16,2(1X,I8),2(1X,I6),1X,I3)
 1001 FORMAT(1X,A1)
C.....Fill CVTLKC
      KC=LNDKC(INDEX)
      IF(INDXKC(KC).EQ.0) INDXKC(KC)=INDEX
      NKC(KC)=MAX(NKC(KC),LNDKCI(INDEX))
C.....READ loop
      GOTO 10
   19 CLOSE(UNIT=IUNIT)
      NTABLE=INDEX
      RETURN
C
      END
