*--------------------------------------------------------------*
*                Converted with cdf2F by G.Velev               *
*--------------------------------------------------------------*
C======================================================================C
      SUBROUTINE CLULIS(MLIST,IUNIT)
C----------------------------------------------------------------------C
C     CDF version of listing program                                   C
C         MLIST= 1 : Print out event by HEPEVT format                  C
C              = 2 : Print out event by GENP format                    C
C              = 3 : Print out conversion map from LUJETS to GENP      C
C              =11 : Print out /LUDAT2/                                C
C              =12 : print out CDF particle table                      C
C----------------------------------------------------------------------C
C Revision history                                                     C
C     1990-10-04 H.Iso Original creation for PYTHIA 5.4 and JETSET 7.3 C
C----------------------------------------------------------------------C
C
      implicit none
C
      INTEGER MLIST,IUNIT
C
C.....PYTHIA/JETSET include files
#include "pythia6.inc" 
#include "generator/hepevt.inc" 
C
C.....CDF interface
#include "cdflnd.inc" 
#include "cvtlnd.inc" 
C
C.....CDF include files
#include "inc/jobsta.inc" 
#include "inc/evsp.inc" 
#include "generator/gnpack.inc" 
#include "generator/genp.inc" 
#include "inc/parbuf.inc" 
#include "inc/partyp.inc" 
C
C.....Mappings, Track informations
      COMMON/CVLMAP/IKMAP,ILMAP,ILPAR,INFOR,ILINHD
      INTEGER IKMAP(NMXLND)   ! Mapping IL -> IK
      INTEGER ILMAP(MAXGEN)   ! Mapping IK -> IL
      INTEGER ILPAR(NMXLND)   ! Mapping IL -> Parent of IL
      INTEGER INFOR(NMXLND)   ! Mapping IK -> IC+100*IS+10000*IA
      INTEGER ILINHD(2)  ! IL of initial state which makes hard collision
C
C.....Local use
      INTEGER ID,IH,IK,IKP1,IKP2,IKD1,IKD2,IL,ILPA,ILD1,ILD2,IG,IT
      INTEGER ITYPE,IFLAV
      INTEGER INDEX,IANTI
      INTEGER J,L,M,JC
      INTEGER KC,KF,KS
      CHARACTER*16 NAMEL
      CHARACTER* 8 NAMEC
      CHARACTER* 6 CSTRG
      CHARACTER* 1 CH1
C
C.....External function
      CHARACTER* 8 PANAME
      REAL*4  PAMASS,PALIFE,PAWIDT,PACHGR,PACHGI
      REAL*4  PAFLAV
      INTEGER PAANTI,PACLAS,PACVRT
C
C...................................................End of declarations/
C
      IF(MLIST.LE.10) THEN
        GOTO(100,200,300),MLIST
      ELSE
        GOTO(1100,1200),(MOD(MLIST,10))
      ENDIF
      RETURN
C
C-----MLIST=1
  100 WRITE(IUNIT,5000) NEVHEP,MSTI(1),MSTI(2),NHEP
      DO 110 IH=1,NHEP
         ID=IDHEP(IH)
         CALL PYNAME(ID,NAMEL)
         WRITE(IUNIT,5100) IH,NAMEL(1:8),IDHEP(IH),ISTHEP(IH)
     &                    ,(JMOHEP(J,IH),J=1,2)
     &                    ,(JDAHEP(M,IH),M=1,2)
     &                    ,(PHEP(L,IH),L=1,5)
  110 CONTINUE
 5000 FORMAT(1H1,'Event number =',I8,3X,'MSTI(1) =',I4
     &      ,3X,'MSTI(2) =',I3,3X,'Number of entry =',I6//
     &1X,'IHEP',1X,'NAME',6X,'IDPDG  IST  MO1  MO2  DA1  DA2',
     &'        P-X        P-Y        P-Z     ENERGY       MASS')
 5100 FORMAT(1X,I4,1X,A8,2X,6I5,5F11.3)
      RETURN
C
C-----MLIST=2
 200  WRITE(IUNIT,5200) NRUN,NEV
5200  FORMAT(//' ====================== COMMON/GENP/ printout for Run ',
     $         I5,' Event  ',I5,
     $         ' ======================'/)
      WRITE(IUNIT,5201) NGEN, NPGEN
5201  FORMAT(' GENP Particle list for total number of particles = ',I5,
     $         ' OBS pointers = ',I5)
C
      WRITE (IUNIT,5210)
      DO 210 IK=1,NGEN
         ID=KGEN(1,IK)
         IG=KGEN(4,IK)
         IT=KGEN(5,IK)
         KF=KGEN(6,IK)
         NAMEC=PANAME(ID)
         IKP1=MOD(KGEN(2,IK),KGPACK)
         IKP2=KGEN(2,IK)/KGPACK
         IKD1=MOD(KGEN(3,IK),KGPACK)
         IF(IKD1.EQ.0) THEN
            IKD2=0
         ELSE
            IKD2=KGEN(3,IK)/KGPACK+1
         ENDIF
         IF(IKP2.NE.0) THEN
            CSTRG='(    )'
            WRITE(CSTRG(2:5),'(I4)') IKP2
         ELSE
            CSTRG='    '
         ENDIF
         WRITE(IUNIT,5220) IK,NAMEC,ID,KF,IKP1,CSTRG,IKD1,IKD2,IG,IT
     &                    ,(PGEN(J,IK),J=1,3),PGEN(5,IK),PGEN(4,IK)
C
  210 CONTINUE
C
 5210 FORMAT(//
     &      ,3X,'IK Name',4X,' CDFid     KF Orig(St)    DA1  #DA'
     &      ,'   G/C  T/C     P-X       P-Y       P-Z'
     &      ,'      ENERGY     MASS')
 5220 FORMAT(1X,I4,1X,A8,I6,I7,I5,A6,2I5,I6,I5,5F10.3)
      RETURN
C
C-----MLIST=3
  300 WRITE(IUNIT,5300) MSTI(5),MSTI(1),MSTI(2),N
      DO 310 IL=1,N
         KS=K(IL,1)
         KF=K(IL,2)
         ILPA=K(IL,3)
         ILD1=K(IL,4)
         ILD2=K(IL,5)
         CALL PYNAME(KF,NAMEL)
         IK=IKMAP(IL)
         IG=KGEN(4,IK)
         IT=KGEN(5,IK)
         ID=KGEN(1,IK)
         IKP1=MOD(KGEN(2,IK),KGPACK)
         IKP2=KGEN(2,IK)/KGPACK
         IKD1=MOD(KGEN(3,IK),KGPACK)
         IF(IKD1.EQ.0) THEN
            IKD2=0
         ELSE
            IKD2=KGEN(3,IK)/KGPACK+1
         ENDIF
         WRITE(IUNIT,5310) IL,IK,NAMEL,KF,ID,KS,IG,IT
     &                    ,ILPA,ILD1,ILD2,IKP1,IKP2,IKD1,IKD2
     &                    ,(P(IL,J),J=1,5)
C
  310 CONTINUE
 5300 FORMAT(1H1,'  Event number =',I8,3X,'MSTI(1) =',I4
     &      ,3X,'MSTI(2) =',I3,3X,'Number of entry =',I6//
     &      ,3X,'IL  IK Name',16X,'KF CDFid   KS   G/C'
     &      ,'  T/C   MO  DA1  DA2 G-P1 G-P2 G-DA G-#D'
     &      ,2X,'   P-X     P-Y     P-Z   ENERGY    MASS')
 5310 FORMAT(1X,2I4,1X,A16,2I6,1X,I4,I6,8I5,1X,5F8.3)
      RETURN
C
C-----MLIST=11
 1100 WRITE(IUNIT,6100)
      DO 1110 KC=1,MXKC
 1110 WRITE(IUNIT,6110) KC,CHAF(KC,1)
     &                 ,(KCHG(KC,J),J=1,3),(PMAS(KC,L),L=1,4)
 6100 FORMAT(2X,'KC Name  KCHG(KC,1)   2)   3)'
     &      ,3X,'PMAS(KC,1)  PMAS(KC,2)  PMAS(KC,3)  PMAS(KC,4)')
 6110 FORMAT(1X,I3,1X,A8,3X,3I5,1X,4E12.3)
      RETURN
C
C-----MLIST=12
 1200 WRITE(IUNIT,6200)
C.....Loop over CDF PARTLIS table
      DO 1210 ID=1,PASIZE
         ITYPE=PACVRT(1,ID)
         IFLAV=ARFLAV(ID)
C........Check this particle has CDF id code in CVTABLE.LND
         JC=0
         DO 1220 INDEX=1,NTABLE
         DO 1220 IANTI=1,2
 1220    IF(CDFIDL(IANTI,INDEX).EQ.ITYPE) JC=JC+1
         IF(JC.EQ.0) THEN
            CH1='X'
         ELSEIF(JC.EQ.1) THEN
            CH1=' '
         ELSE
            WRITE(CH1,'(I1)') JC
         ENDIF
C........Print out
 1230    WRITE(IUNIT,6210) ID,ITYPE,CH1,PANAME(ITYPE),ARDKLV(ID),IFLAV
     &                    ,PACHGR(ITYPE),PAMASS(ITYPE),PALIFE(ITYPE)
     &                    ,PAWIDT(ITYPE)
 1210 CONTINUE
 6200 FORMAT(3X,'ID ITYPE   NAME    DKLV     FLAV'
     & ,1X,'   CHARGE  ','    MASS   ','  LIFE TIME','   WIDTH   ')
 6210 FORMAT(1X,I4,I6,1X,A1,1X,A8,I4,1X,I8,1X,4E11.3)
      RETURN
C
      END
