*--------------------------------------------------------------*
*                Converted with cdf2F by G.Velev               *
*--------------------------------------------------------------*
C VAX/DEC CMS REPLACEMENT HISTORY, Element CONVPY.CDF
C *8    13-APR-1993 17:58:27 EINSWEIL "new code for PYTHIA 5.6"
C *7    20-AUG-1992 12:18:38 EINSWEIL "update to include clusters, fix string po
C *6    12-JUN-1991 18:04:39 MDSHAPIRO "Unix port"
C *5     2-APR-1991 07:32:53 ISO "CDF version of PYTHIA 5.4/JETSET 7.3"
C *4    21-MAY-1988 11:10:07 GALTIERI "changed to run faster"
C *3    18-MAY-1988 13:43:25 GALTIERI "Change UCLALIB to PYTHIA$LIBRARY"
C *2    17-MAY-1988 02:27:19 GALTIERI "Updated to V4.9 & much faster"
C *1    12-MAY-1988 23:53:23 GALTIERI "Coverts PYTHIA to CDF Format. V4.9"
C VAX/DEC CMS REPLACEMENT HISTORY, Element CONVPY.CDF
C DEC/CMS REPLACEMENT HISTORY, Element CONVPY.CDF
C *7    20-AUG-1992 12:18:38 EINSWEIL "update to include clusters, fix string po
C *6    12-JUN-1991 18:04:39 MDSHAPIRO "Unix port"
C *5     2-APR-1991 07:32:53 ISO "CDF version of PYTHIA 5.4/JETSET 7.3"
C *4    21-MAY-1988 11:10:07 GALTIERI "changed to run faster"
C *3    18-MAY-1988 13:43:25 GALTIERI "Change UCLALIB to PYTHIA$LIBRARY"
C *2    17-MAY-1988 02:27:19 GALTIERI "Updated to V4.9 & much faster"
C *1    12-MAY-1988 23:53:23 GALTIERI "Coverts PYTHIA to CDF Format. V4.9"
C DEC/CMS REPLACEMENT HISTORY, Element CONVPY.CDF
C======================================================================C
      SUBROUTINE CONVPY
C----------------------------------------------------------------------C
C     Convert PYTHIA/JETSET event informations to GENP                 C
C----------------------------------------------------------------------C
C Revision history                                                     C
C     1990-10-04 H.Iso Original creation for PYTHIA 5.4 and JETSET 7.3 C
C----------------------------------------------------------------------C
C
      implicit none
C
C.....PYTHIA/JETSET include files
#include "pythia6.inc" 
C
C.....Particle conversion table
#include "cdflnd.inc" 
#include "cvtlnd.inc" 
C
C.....CDF include files
#include "inc/jobsta.inc" 
#include "inc/evsp.inc" 
#include "generator/gnpack.inc" 
#include "generator/genp.inc" 
C
C.....Mappings, Track informations
      INTEGER IKMAP(NMXLND)   ! Mapping IL -> IK
      INTEGER ILMAP(MAXGEN)   ! Mapping IK -> IL
      INTEGER ILPAR(NMXLND)   ! Mapping IL -> Parent of IL
      INTEGER INFOR(NMXLND)   ! Mapping IK -> IC+100*IS+10000*IA
      INTEGER ILINHD(2)       ! IL of initial state which makes hard collision
      COMMON/CVLMAP/IKMAP,ILMAP,ILPAR,INFOR,ILINHD
C where
C     IK = GENP   pointer
C     IL = LUJETS pointer
C     IC = Class  number( 1: BEAM, 2: HARD, 3: SHOWER, 4: PARTICLE )
C     IS = String number
C     IA = Other  informations
C
C.....String pointer
      INTEGER MXSTRG
      PARAMETER( MXSTRG = 100 )
      INTEGER NSTRNG,ILSTRG
      COMMON/CVLSTG/NSTRNG,ILSTRG(MXSTRG,2)
C
C.....Local use
      INTEGER IA,IC,IS,IST
      INTEGER IK,IKT,IKP1,IKP2,IKPE,IL,ILD1,ILD2,ILPA,ILP,ILT,II
      INTEGER IGC,ITC
      INTEGER INDEX,INDEX1,INDEX2,IANTI,IANTI1,IANTI2,J
      INTEGER KC,KC1,KC2,KF,KFP1,KFP2,KFPX,KS,KCI,KCT
      INTEGER KPACK
      INTEGER NEVENT
C
C.....External functions
      LOGICAL CVLREJ
C      INTEGER PYCOMP
C
C.....Data statement
      DATA NEVENT/0/
C
C.....Save everythings
      SAVE
C
C...................................................End of declarations/
C
C----------------------------------------------------------------------C
C   A.Error code : Assume abnormal filling                             C
C----------------------------------------------------------------------C
C
      KEVSP(11)=1
C
C----------------------------------------------------------------------C
C   B.Make mappings between LUJETS and GENP                            C
C----------------------------------------------------------------------C
C
C=====B.0.Some initializations
C
      KPACK=NKGPAK
C
C.....Initialize GENP pointer
      IK=0
C.....Initialize mappings, parent pointer, string number
      CALL VZERO(IKMAP(1),NMXLND)
      CALL VZERO(ILMAP(1),MAXGEN)
      CALL VZERO(ILPAR(1),NMXLND)
      CALL VZERO(INFOR(1),NMXLND)
      CALL VZERO(ILINHD(1),2)

C
C=====B.1.NoUnst case
      IF(NOUNST) THEN
         DO 1000 IL=1,N
            KS=K(IL,1)
            IF(KS.EQ.1) THEN
               IK=IK+1
               IKMAP(IL)=IK
               ILMAP(IK)=IL
            ENDIF
 1000    CONTINUE
         GOTO 3000
      ENDIF
C
C=====B.2.Make 1) IKMAP : mapping IL -> IK
C              2) ILMAP : mapping IK -> IL
C              3) ILPAR : mapping IL -> IL parents
C              4) INFOR : mapping IL -> IC+100*IS+10000*IA ( by CVLREJ )
C
C-----Loop over LUJETS tracks
      DO 2000 IL=1,N
C
C--------Track informations
         KS  =K(IL,1)    ! Status code
         KF  =K(IL,2)    ! KF id code
         KC  =PYCOMP(KF) ! Compressed id code
         ILPA=K(IL,3)    ! Parent pointer
         ILD1=K(IL,4)    ! 1st daughter pointer
         ILD2=K(IL,5)    ! 2nd daughter pointer
C
C--------Save IL parent pointer
         ILPAR(IL)=ILPA
C
C--------Skip this track( INFOR is definded in CVLREJ )
         IF(CVLREJ(IL,KF,KC,KS,ILPA,ILD1,ILD2)) GOTO 2000
C
C--------Increment GENP pointer, and define mappings
         IK=IK+1
C........Reservation for non existent tracks
C        None
C........Make mappings
         IKMAP(IL)=IK
         ILMAP(IK)=IL
C
 2000 CONTINUE
C
C----------------------------------------------------------------------C
C   C.Fill PGEN and KGEN array                                         C
C----------------------------------------------------------------------C
C
 3000 NGEN=MIN(IK,MAXGEN)
      NPGEN=0
C-----Loop over GENP tracks
      DO 6000 IK=1,NGEN
C
         IL=ILMAP(IK)                   ! LUJETS pointer
         IA=INFOR(IL)/10000             ! Additional information
         IS=MOD(INFOR(IL),10000)/100    ! String number
         IC=MOD(INFOR(IL),100)          ! Class number
         ILPA=ILPAR(IL)                 ! Parent IL pointer
         KS=K(IL,1)                     ! Status code
         KF=K(IL,2)                     ! KF id code
C
C=====Search for the parent in GENP
C
C--------Initial point
         ILT=IL                         ! Current track
         IST=IS                         ! String number of the track
         ILP=ILPA                       ! Parent track of the track
C
C--------Loop of parent search
 4000    CONTINUE
C........No parent in LUJETS
         IF(ILP.EQ.0) THEN
            IKP1=0
            IKP2=0
C........This track is string or cluster
         ELSEIF(K(ILT,2).EQ.92.OR.K(ILT,2).EQ.91) THEN
            IKP1=IKMAP(ILSTRG(IST,1))
            IKP2=IKMAP(ILSTRG(IST,2))
C........There is a parent in GENP
         ELSEIF(IKMAP(ILP).GE.1) THEN
            IKP1=IKMAP(ILP)
            IKP2=0
C........Otherwise replace track by parent and recurrent to search
         ELSE
            ILT=ILP
            IST=MOD(INFOR(ILT),10000)/100
            ILP=ILPAR(ILT)
            GOTO 4000
         ENDIF
C--------End of the loop
C
C--------Define KF id code of the parent if available
         IF(IKP1.NE.0) THEN
            KFP1=K(ILMAP(IKP1),2)
            IF(IABS(KFP1).EQ.89) THEN
               KFPX=ISIGN(1,KFP1)*24
            ELSE
               KFPX=KFP1
            ENDIF
            CALL CLGIDX(KFPX,INDEX1,IANTI1)
            IF(INDEX1.NE.0) KC1=LNDKC(INDEX1)
         ELSE
            KFP1=0
         ENDIF
         IF(IKP2.NE.0) THEN
            KFP2=K(ILMAP(IKP2),2)
            IF(IABS(KFP2).EQ.89) THEN
               KFPX=ISIGN(1,KFP2)*24
            ELSE
               KFPX=KFP2
            ENDIF
            CALL CLGIDX(KFPX,INDEX2,IANTI2)
            IF(INDEX2.NE.0) KC2=LNDKC(INDEX2)
         ELSE
            KFP2=0
         ENDIF
C
C=====KGEN
C
C  (1) Save particle id to GENP and Define KC, KCI
C
         CALL CLGIDX(KF,INDEX,IANTI)
         IF(INDEX.NE.0) THEN
            KGEN(1,IK)=CDFIDL(IANTI,INDEX)
            KC        =LNDKC (INDEX)
            KCI       =LNDKCI(INDEX)
         ELSEIF(IABS(KF).EQ.89) THEN
            KGEN(1,IK)=104-(ISIGN(1,KF)+1)/2
            KC=89
            KCI=0
         ELSE
            KGEN(1,IK)=0
            KC        =0
            KCI       =0
         ENDIF
         KGEN(6,IK)=KF
C
C  (2) Define G-code IGC of IK, T-code ITC of IKP
C
C--------NoUnst case
         IF(NOUNST) THEN
            IGC=0
            ITC=0
            GOTO 3900
         ENDIF
C
C--------Assume no T/C of parent found
         ITC=-1
C
C--------Different processing for different class of track
         GOTO(3100,3200,3300,3400,3500),IC
C
C--------IC=1: Beam
 3100    IGC=IA
         GOTO 3900
C
C--------IC=2: Hard proc
 3200    IGC=IA
C........Define ILINHD: IL pointer of hard collided initial state
         II=IA/10
         IF(II.EQ.1.OR.II.EQ.2) ILINHD(II)=IL
C........Skip if there is no parent
         IF(IKP1.LE.0) GOTO 3900
C........Initial state from beam
         IF(IA.EQ.10.OR.IA.EQ.20) THEN
            ITC=101
C........Parent is color singlet boson
         ELSEIF(IABS(KFP1).GE.22.AND.IABS(KFP1).LE.40) THEN
            ITC=30
C........Parent is color singlet, not boson
         ELSEIF(KCHG(KC1,2).EQ.0) THEN
            IF(INDEX1.NE.0) THEN
               ITC=CDFTCL(INDEX1)
               IF(ITC.EQ.0) ITC=99
            ENDIF
C........Parent is a parton
         ELSE
            IF(KCHG(KC,2).EQ.0) THEN
               ITC=311
            ELSE
               ITC=301
            ENDIF
         ENDIF
         GOTO 3900
C
C
C--------IC=3: Parton shower
C........Spectator
 3300    IF(IA.EQ.1.OR.IA.EQ.2) THEN
            IGC=4+IA
            IF(IS.EQ.0) IGC=IGC+100
C........No parent
         ELSEIF(IA.EQ.0) THEN
            IGC=7
            IF(IS.EQ.0) IGC=IGC+100
C........Color singlet, from hard process, not hadron
         ELSEIF(IA.EQ.9) THEN
C         * Spectator
            IF(ILPA.EQ.1.OR.ILPA.EQ.2) THEN
               IGC=104+ILPA
C         * Decay!?
            ELSE
               IF(IKP1.GE.1) THEN
                  IGC=2000+MOD(KGEN(4,IKP1),1000)
               ELSE
                  IGC=2000
               ENDIF
               IF(INDEX1.NE.0) THEN
                  ITC=CDFTCL(INDEX1)
                  IF(ITC.EQ.0) ITC=99
               ENDIF
            ENDIF
C........Parton from parton with G/C=n*10,n*10+1
         ELSE
            IGC=IA
            ITC=301
         ENDIF
         GOTO 3900
C
C--------IC=4: Particle
C........String
 3400    IF(IA.EQ.3) THEN
            IGC=20000
            IF(KGEN(4,IKP1).EQ.70) IGC=20070
            ITC=307
C........Hadron directly from string or cluster
         ELSEIF(IA.EQ.2) THEN
            IGC=1700
            IF(KGEN(6,IKP1).EQ.92.OR.KGEN(6,IKP1).EQ.91) THEN
               IGC=IGC+MOD(KGEN(4,IKP1),100)
               ITC=500
            ELSE
               IF(KGEN(4,IKP1).EQ.70) IGC=1770
               ITC=307
            ENDIF
C........Hadron from shower( unusual except for use of IF )
         ELSEIF(IA.EQ.4) THEN
C...........Decay
            IF(KCHG(KC1,2).EQ.0) THEN
               IGC=2000+MOD(KGEN(4,IKP1),1000)
               IF(INDEX1.NE.0) THEN
                  ITC=CDFTCL(INDEX1)
                  IF(ITC.EQ.0) ITC=99
               ENDIF
C...........Hadronized by IF method
            ELSEIF(MSTJ(1).EQ.1) THEN
               IGC=1600+MOD(KGEN(4,IKP1),100)
               ITC=306
            ELSE
               IGC=107
            ENDIF
C........No parent
         ELSEIF(IA.EQ.0) THEN
            IGC=107
C........Decay product of hadron
         ELSE
            IGC=2000+MOD(KGEN(4,IKP1),1000)
            IF(INDEX1.NE.0) THEN
               ITC=CDFTCL(INDEX1)
               IF(ITC.EQ.0) ITC=99
            ENDIF
         ENDIF
         GOTO 3900
C
C--------Parton in heavy flavor decay
 3500    IGC=70
         IF(INDEX1.NE.0) THEN
            ITC=CDFTCL(INDEX1)
            IF(ITC.EQ.0) ITC=99
         ENDIF
         GOTO 3900
C
 3900    CONTINUE
C
C--------Assume left over
         KGEN(3,IK)=0
         IF(KCHG(KC,2).NE.0) THEN
            KGEN(5,IK)=309
         ELSE
            KGEN(5,IK)= 99
         ENDIF
C
C--------This is a stable final particle
         IF(KS.EQ.1) THEN
            KGEN(5,IK)=0
            NPGEN=NPGEN+1
            KPGEN(NPGEN)=IK
         ENDIF
C
C--------Parent pointer( put string number in 2nd )
         IF(IKP2.EQ.0) THEN
C           KGEN(2,IK)=IKP1+KPACK*IS
            KGEN(2,IK)=IKP1
         ELSE
C           KGEN(2,IK)=KPACK*IS
            KGEN(2,IK)=IKP1+KPACK*IKP2
         ENDIF
C
C--------Generation code
         KGEN(4,IK)=IGC
C
C--------Fill daughter pointer and T-code of parent track(s)
C........Spectator from beam: Do nothing for parent D,T codes
         IF(IC.EQ.3.AND.(IA.EQ.1.OR.IA.EQ.2)) GOTO 5000
C........There are parents
         IF(IKP1.GE.1) THEN
            IF(IKP2.GE.IKP1) THEN
               IKPE=IKP2
            ELSE
               IKPE=IKP1
            ENDIF
            DO 4500 IKT=IKP1,IKPE
               ILT=ILMAP(IKT)
               KCT=PYCOMP(K(ILT,2))
               IF(KCHG(KCT,2).NE.0) THEN
                  CALL SVKG35(IKT,IK,309,ITC)
               ELSE
                  CALL SVKG35(IKT,IK, 99,ITC)
               ENDIF
 4500       CONTINUE
         ENDIF
C
C=====PGEN : save 4-momenta, mass to PGEN
C
 5000    CONTINUE
         DO 5100 J=1,3
 5100    PGEN(J,IK)=P(IL,J)
         PGEN(4,IK)=P(IL,5)
         PGEN(5,IK)=P(IL,4)
C
 6000 CONTINUE
C
C=====Set T/C of initial state which makes hard collision
      DO 6100 J=1,2
         IL=ILINHD(J)
         IF(IL.GE.1) THEN
            IK=IKMAP(IL)
            IF(IK.GE.1) KGEN(5,IKMAP(IL))=302
         ENDIF
 6100 CONTINUE
C
C----------------------------------------------------------------------C
C   D.Fill EVSP                                                        C
C----------------------------------------------------------------------C
C
      NEVENT=NEVENT+1
      NEV=NEVENT
      KEVSP( 1)=NEV     ! Event number
      KEVSP( 2)=MSTI(3) ! Number of hard process call
      KEVSP( 3)=NGEN    ! Total number of generated particles
      KEVSP( 4)=NPGEN   ! No. of production vertex generation particles
      KEVSP( 8)=MSTI(1) ! ISUB code
      KEVSP( 9)=MSTI(2) ! Color flow number
      KEVSP(10)=0       ! Event generation random number Seed
C
      PEVSP( 1)=1.      ! Relative event weight
      PEVSP( 2)=PARI(1) ! Corresponding integrated cross section/mb
      PEVSP( 3)=PEVSP(3)+PEVSP(1) ! Accumulated PEVSP(1)
C
      KEVSP(11)=0       ! Reset error code
C
      RETURN
      END
