C...This file contains a complete listing of all PYTHIA 
C...commonblocks, and additionally some recommended other 
C...declarations. You may copy this to the top of your
C...mina program and then eliminate unnecessary parts.

C-----------------------------------------------------------------
 
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, excited fermions).
      INTEGER KSUSY1,KSUSY2,KEXCIT
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KEXCIT=4000000)

C...NMXLND
      INTEGER NMXLND
      PARAMETER (NMXLND=4000)

C...Commonblocks.
C...The event record.
      INTEGER N,NPAD,K(4000,5)
      DOUBLE PRECISION P(4000,5),V(4000,5)
      COMMON/PYJETS/N,NPAD,K,P,V
C...Parameters.
      INTEGER MSTU(200),MSTJ(200)
      DOUBLE PRECISION PARU(200),PARJ(200)
      COMMON/PYDAT1/MSTU,PARU,MSTJ,PARJ
C...Particle properties + some flavour parameters.
      INTEGER KCHG(500,4)
      DOUBLE PRECISION PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON/PYDAT2/KCHG,PMAS,PARF,VCKM
C...Decay information.
      INTEGER MDCY(500,3),MDME(4000,2),KFDP(4000,5)
      DOUBLE PRECISION BRAT(4000)
      COMMON/PYDAT3/MDCY,MDME,BRAT,KFDP
C...Particle names
      CHARACTER CHAF(500,2)*16
      COMMON/PYDAT4/CHAF
C...Random number generator information.
      INTEGER MRPY(6)
      DOUBLE PRECISION RRPY(100)
      COMMON/PYDATR/MRPY,RRPY
C...Selection of hard scattering subprocesses.
      INTEGER MSEL,MSELPD,MSUB(500),KFIN(2,-40:40)
      DOUBLE PRECISION CKIN(200)
      COMMON/PYSUBS/MSEL,MSELPD,MSUB,KFIN,CKIN
C...Parameters. 
      INTEGER MSTP(200),MSTI(200)
      DOUBLE PRECISION PARP(200),PARI(200)
      COMMON/PYPARS/MSTP,PARP,MSTI,PARI
C...Internal variables.
      INTEGER MINT(400)
      DOUBLE PRECISION VINT(400)
      COMMON/PYINT1/MINT,VINT
C...Process information.
      INTEGER ISET(500),KFPR(500,2),ICOL(40,4,2)
      DOUBLE PRECISION COEF(500,20)
      COMMON/PYINT2/ISET,KFPR,COEF,ICOL
C...Parton distributions and cross sections.
      INTEGER ISIG(1000,3)
      DOUBLE PRECISION XSFX(2,-40:40),SIGH(1000)
      COMMON/PYINT3/XSFX,ISIG,SIGH
C...Resonance width and secondary decay treatment.
      INTEGER MWID(500)
      DOUBLE PRECISION WIDS(500,5)
      COMMON/PYINT4/MWID,WIDS
C...Generation and cross section statistics.
      INTEGER NGENPD,NGENPY(0:500,3)
      DOUBLE PRECISION XSEC(0:500,3)
      COMMON/PYINT5/NGENPD,NGENPY,XSEC
C...Process names.
      CHARACTER PROC(0:500)*28
      COMMON/PYINT6/PROC
C...Total cross sections.
      DOUBLE PRECISION SIGT(0:6,0:6,0:5)
      COMMON/PYINT7/SIGT
C...Photon parton distributions: total and valence only.
      DOUBLE PRECISION XPVMD(-6:6),XPANL(-6:6),XPANH(-6:6),XPBEH(-6:6),
     &XPDIR(-6:6)
      COMMON/PYINT8/XPVMD,XPANL,XPANH,XPBEH,XPDIR
      DOUBLE PRECISION VXPVMD(-6:6),VXPANL(-6:6),VXPANH(-6:6),
     &VXPDGM(-6:6) 
      COMMON/PYINT9/VXPVMD,VXPANL,VXPANH,VXPDGM 
C...Setting up user-defined processes.
      INTEGER NUP,KUP(20,7),NFUP,IFUP(10,2)
      DOUBLE PRECISION PUP(20,5),Q2UP(0:10)
      COMMON/PYUPPR/NUP,KUP,NFUP,IFUP,PUP,Q2UP
C...Supersymmetry parameters.
      INTEGER IMSS(0:99)
      DOUBLE PRECISION RMSS(0:99)
      COMMON/PYMSSM/IMSS,RMSS
C...Supersymmetry mixing matrices.
      DOUBLE PRECISION ZMIX(4,4),UMIX(2,2),VMIX(2,2),SMZ(4),SMW(2),
     &SFMIX(16,4)
      COMMON/PYSSMT/ZMIX,UMIX,VMIX,SMZ,SMW,SFMIX
C...Parameters for Gauss integration of supersymmetric widths.
      DOUBLE PRECISION XXM(20)
      COMMON/PYINTS/XXM
C...Histogram information.
      INTEGER IHIST(4),INDX(1000)
      DOUBLE PRECISION BIN(20000)
      COMMON/PYBINS/IHIST,INDX,BIN
